# Contributing

We'd love for you to contribute to our source code and to make BioJS even better than it is
today! The BioJS community is very young and rapidly growing - so we are still working on making it more smooth for newcomers to get started. Nevertheless we have some general advices for you to make an awesome contribution.

 - [How to get started](#getstarted)
 - [How to contribute](#howto)
 - [Issues and Bugs](#issue)
 - [Feature/Component requests](#feature)
 - [Submission guidelines](#submission)

## <a name="getstarted"></a> How to get started?

* Learn how to create your [own BioJS][edu] component
* Look at [existing components][registry] and learn how they are written
* Here is a list of [services provides by BioJS](https://github.com/biojs/biojs/wiki/BioJS-services)

Interesting talks:

* [BioJS tech fundamentals](http://slides.biojs.net/ebi-tech-fundamentals-1/#/22)
* [Reusable JavaScript](https://docs.google.com/presentation/d/1XmLTOI066-mOKGgUe3ynr1LcSpJsfHrTo-u2YK1vVhc/)
* [Intro into HTML](http://slides.biojs.net/ebi-tech-fundamentals-2/#/)
* [Intro into JS](https://greenify.github.io/js-intro/#/)
* [Advanced JS](http://greenify.github.io/js-adv)

You can find more [talks here](https://github.com/biojs-edu/talks).

## <a name="howto"></a> How to contribute?

Here are some general ideas:

* Browse our [issue list][issue] (or [all BioJS repositories][issues_all]) for ideas
* [Propose][issue_new] your own ideas
* Don't hesitate to ask more __specific questions__ on [github][issue_new], [gitter][gitter] or our [mailing list][groups]

Your contribution could be:

1. Improve an existing component and send a pull request (see the BioJS [registry][registry])
2. Create your own component (see the [wishlist][wishlist] if you don't have an own idea)
3. Help us at building the BioJS infrastructure (registry, docs, ...)
(not a complete list)

If you are about to create a new component, is generally a good idea to ask us (github issues, gitter, irc) if someone is already working on a similar project.

## <a name="issue"></a> Found an Issue?

If you find a bug in the source code or a mistake in the documentation, you can help us by
submitting an issue to our [GitHub Repository][github]. Even better you can submit a Pull Request
with a fix.

## <a name="feature"></a> Want a Feature/Component?

You can request a new feature by submitting an issue to our [GitHub Repository][github].  If you
would like to implement a new feature or component, you can also get help on our issue tracker ;-)

## <a name="submission"></a> Submission Guidelines

Before you submit your issue search the archive, maybe your question was already answered.

* Search [GitHub](https://github.com/biojs/biojs/issues?q=) for an open or closed issue or pull request
  that relates to your submission. You don't want to duplicate effort.
* If your issue appears to be a bug, and hasn't been reported, open a new issue.

Help us to maximize the effort we can spend fixing issues and adding new
features, by not reporting duplicate issues.  Providing the following information will increase the
chances of your issue being dealt with quickly:

* **Overview of the Issue** - if an error is being thrown a non-minified stack trace helps
* **Motivation for or Use Case** - explain why this is a bug for you
* **Related Issues** - has a similar issue been reported before?
* **Suggest a Fix** - if you can't fix the bug yourself, perhaps you can point to what might be
  causing the problem (line of code or commit)

That's it! Thank you for your contribution!

We are happy to help you via [Gitter][gitter], [Google groups][groups] or [IRC][irc].

[edu]: http://edu.biojs.net/categories/101_tutorial/index.html
[github]: https://github.com/biojs/biojs
[gitter]: https://gitter.im/biojs/biojs
[groups]: https://groups.google.com/forum/#!forum/biojs
[irc]: http://webchat.freenode.net/?channels=biojs 
[issue]: https://github.com/biojs/biojs/issues
[issue_new]: https://github.com/biojs/biojs/issues/new
[issues_all]: https://github.com/search?l=&o=desc&q=user%3Abiojs+state%3Aopen&ref=advsearch&s=created&type=Issues&utf8=%E2%9C%93 
[registry]: http://biojs.io
[wishlist]: https://github.com/biojs/biojs/issues?q=is%3Aopen+is%3Aissue+label%3Awishlist
